package org.zeroturnaround.javarebel.integration.spring.cbp;

import org.zeroturnaround.bundled.javassist.ClassPool;
import org.zeroturnaround.bundled.javassist.CtClass;
import org.zeroturnaround.bundled.javassist.CtConstructor;
import org.zeroturnaround.bundled.javassist.CtMethod;
import org.zeroturnaround.bundled.javassist.CtNewMethod;
import org.zeroturnaround.javarebel.ClassEventListener;
import org.zeroturnaround.javarebel.integration.support.JavassistClassBytecodeProcessor;

public class DefaultAnnotationHandlerMappingCBP extends JavassistClassBytecodeProcessor {

  public void process(ClassPool cp, ClassLoader cl, CtClass ctClass) throws Exception {
    cp.importPackage("java.lang.ref");
    cp.importPackage("org.zeroturnaround.javarebel");

    // Empties cache
    ctClass.addInterface(cp.get(ClassEventListener.class.getName()));   
    CtConstructor init = ctClass.getDeclaredConstructor(new CtClass[] {});
    init.insertAfter(
        "ReloaderFactory.getInstance().addClassReloadListener(new WeakReference($0));");   

    CtMethod priorityMethod = CtNewMethod.make("public int priority() {\n" + 
        "    return PRIORITY_CORE + 9800;\n" + 
        "  }", ctClass);

    ctClass.addMethod(priorityMethod);

    CtMethod onClassEventMethod = CtNewMethod.make(
        " public void onClassEvent(int eventType, Class beanClass) {\n" +
        "   cachedMappings.remove(beanClass);" + 
        " }",
        ctClass);
    ctClass.addMethod(onClassEventMethod);
  }
}
